datablock PlayerData(PlayerRider : PlayerStandardArmor)
{
	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

	uiName = "Horse Rider";
	showEnergyBar = false;
};

package HorseRider
{
	function Armor::onNewDatablock(%this,%obj)
	{
		Parent::onNewDatablock(%this,%obj);
		if(isObject(%obj.ridingHorse))
			%obj.ridingHorse.removeBody();
		
		if(%this == PlayerRider.getID())
			%obj.schedule(10,spawnHorse);
	}
	
	function Armor::onUnMount(%this,%obj,%vehicle,%slot)
	{
		%r = Parent::onUnMount(%this,%obj,%vehicle,%slot);
		if(%this == PlayerRider.getID() && %vehicle == %obj.ridingHorse)
		{
			if(%obj.ridingHorse.getState() $= "Dead")
				%obj.horseDead = 1;
			else
			{
				%obj.horseDamage = %obj.ridingHorse.getDamageLevel();
				%vehicle.removeBody();
			}
		}
		return %r;
	}
	
	function Armor::onTrigger(%this,%obj,%slot,%on)
	{
		%r = Parent::onTrigger(%this,%obj,%slot,%on);
		if(%this == PlayerRider.getID() && %slot == 4 && %on && !isObject(%obj.ridingHorse) && !%obj.horseDead)
			%obj.spawnHorse();
		return %r;
	}
	
	function Armor::onDisabled(%this,%obj)
	{
		if(%this == PlayerRider.getID() && %vehicle == %obj.ridingHorse)
			%vehicle.kill();
		
		Parent::onDisabled(%this,%obj);
	}
};activatePackage(HorseRider);

function Player::spawnHorse(%obj)
{
	%t = %obj.getTransform();
	%v = %obj.getVelocity();
	
	%bot = new AIPlayer()
	{
		dataBlock = horseArmor;
	};MissionCleanup.add(%bot);
	%bot.setTransform(vectorAdd(posFromTransform(%t),"0 0 0") SPC rotFromTransform(%t));
	
	if(isObject(%obj.client))
	{
		%bot.brickGroup = %obj.client.brickgroup;
		%bot.lastControllingClient = %obj.client;
		if(isObject(%obj.client.minigame) && isObject(GameModeStorerSO) && %obj.client.tdmTeam != -1)
			%bot.setNodeColor("ALL",getColorIDTable(%obj.client.minigame.teamCol[%obj.client.tdmTeam]));
		else
			%bot.setNodeColor("ALL",%obj.client.chestColor);
	}
	
	if(isObject(%obj.client.minigame))
		%g = %obj.client.minigame.owner.brickgroup;
	else if(isObject(%obj.client.brickgroup))
		%g = %obj.client.brickgroup;
	else
		%g = mainBrickGroup.getObject(0);
	
	for(%i=0;%i<%g.getCount();%i++)
	{
		%o = %g.getObject(%i);
		if(%o.dataBlock.bricktype != 2)
		{
			%bot.spawnBrick = %o;
			break;
		}
	}
	
	%bot.mountObject(%obj,2);
	%bot.setVelocity(%v);
	%bot.setDamageLevel(%obj.horseDamage);
	%obj.schedule(300,setControlObject,%bot);
	%obj.schedule(300,setTransform,"0 0 0 1 0 0 0");
	%obj.canDismount = 0;
	%obj.schedule(1000,resetDismount);
	
	%obj.ridingHorse = %bot;
}

function Player::resetDismount(%obj)
{
	%obj.canDismount = 1;
}